<!DOCTYPE html>
<html>
  <head>
    <title>Task 40.20</title>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />
    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>

  <body>
    <!-- Vùng header -->
    <div class="container-fluid">
      <div class="text-center">
        <h2>List Courses</h2>
      </div>
      <div class="form-group">
        <button class="btn btn-success" id="btn-add-courses">
          <i class="fa fa-plus"></i>&nbsp; Add Course
        </button>
      </div>

      <!-- Courses Data Table -->
      <table
        class="table table-bordered table-striped table-hover"
        id="table-course"
      >
        <thead class="thead-dark">
          <tr>
            <th scope="col">STT</th>
            <th scope="col">Cover Image</th>
            <th scope="col">Course Code</th>
            <th scope="col">Course Name</th>
            <th scope="col">Level</th>
            <th scope="col">Duration</th>
            <th scope="col">Price</th>
            <th scope="col">Discount Price</th>
            <th scope="col">Teacher Name</th>
            <th scope="col">Teacher Photo</th>
            <th scope="col">Is Popular</th>
            <th scope="col">Is Trending</th>
            <th scope="col">Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <!-- Vùng Modal -->

    <!-- Create user modal -->
    <div
      id="insert-course-modal"
      class="modal fade"
      tabindex="-1"
      data-backdrop="static"
      data-keyboard="false"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Creat course</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-cover">Cover Image</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-course-photo"
                    name="coverImage"
                    placeholder="Exp: images/courses/course-css.jpg"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-course-code">Course Code</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-course-code"
                    name="courseCode"
                    placeholder="Course Code"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-course-name">Course Name</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-course-name"
                    name="coursename"
                    placeholder="Course Name"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-level">Level</label>
                </div>
                <div class="col-sm-8">
                  <select
                    name="select-modal-level"
                    id="select-modal-level"
                    class="form-control"
                  >
                    <option value="NOT_SELECT_LEVEL">Chọn</option>
                    <option value="Beginner">Beginner</option>
                    <option value="Intermediate">Intermediate</option>
                    <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-modal-popular">Popular</label>
                </div>
                <div class="col-sm-8">
                  <select
                    name="select-modal-popular"
                    id="select-modal-popular"
                    class="form-control"
                  >
                    <option value="NOT_SELECT_POPULAR">Chọn</option>
                    <option value="true">true</option>
                    <option value="false">False</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-modal-trending">Trending</label>
                </div>
                <div class="col-sm-8">
                  <select
                    name="select-modal-trending"
                    id="select-modal-trending"
                    class="form-control"
                  >
                    <option value="NOT_SELECT_TRENDING">Chọn</option>
                    <option value="true">true</option>
                    <option value="false">False</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-duration">Duration</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-duration"
                    name="duration"
                    placeholder="Example: 3h 30m"
                    class="form-control"
                  />
                </div>
              </div>

              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-price">Price</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-price"
                    name="price"
                    placeholder="Example: 100$"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-discount">Discount Price</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-discount"
                    name="discount"
                    placeholder="Example: 90$"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-teacher-name">Teacher Name</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-teacher-name"
                    name="teachername"
                    placeholder="Teacher Name"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="teacherPhoto">Teacher Photo</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-modal-teacher-photo"
                    name="teacherPhoto"
                    placeholder="Exp: images/teacher/ted_hawkins.jpg"
                    class="form-control"
                  />
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-create">
              Insert Course
            </button>
            <button
              class="btn btn-secondary"
              id="btn-modal-cancel"
              data-dismiss="modal"
            >
              Cancel
            </button>
          </div>
        </div>
      </div>
    </div>
    <!-- Update user modal -->
    <div
      id="update-course-modal"
      class="modal fade"
      tabindex="-1"
      data-backdrop="static"
      data-keyboard="false"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Update course</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-cover">Cover Image</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-update-modal-course-photo"
                    name="coverImage"
                    placeholder="Exp: images/courses/course-css.jpg"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-course-code">Course Code</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-update-modal-course-code"
                    name="courseCode"
                    placeholder="Course Code"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-course-name">Course Name</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-update-modal-course-name"
                    name="coursename"
                    placeholder="Course Name"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-level">Level</label>
                </div>
                <div class="col-sm-8">
                  <select
                    name="select-modal-level"
                    id="select-update-modal-level"
                    class="form-control"
                  >
                    <option value="NOT_SELECT_LEVEL">Chọn</option>
                    <option value="Beginner">Beginner</option>
                    <option value="Intermediate">Intermediate</option>
                    <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-modal-popular">Popular</label>
                </div>
                <div class="col-sm-8">
                  <select
                    name="select-modal-popular"
                    id="select-update-modal-popular"
                    class="form-control"
                  >
                    <option value="NOT_SELECT_POPULAR">Chọn</option>
                    <option value="true">true</option>
                    <option value="false">False</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-modal-trending">Trending</label>
                </div>
                <div class="col-sm-8">
                  <select
                    name="select-modal-trending"
                    id="select-update-modal-trending"
                    class="form-control"
                  >
                    <option value="NOT_SELECT_TRENDING">Chọn</option>
                    <option value="true">true</option>
                    <option value="false">False</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-duration">Duration</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-update-modal-duration"
                    name="duration"
                    placeholder="Example: 3h 30m"
                    class="form-control"
                  />
                </div>
              </div>

              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-price">Price</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="number"
                    id="input-update-modal-price"
                    name="price"
                    placeholder="Example: 100$"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-discount">Discount Price</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="number"
                    id="input-update-modal-discount"
                    name="discount"
                    placeholder="Example: 90$"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-modal-teacher-name">Teacher Name</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-update-modal-teacher-name"
                    name="teachername"
                    placeholder="Teacher Name"
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="teacherPhoto">Teacher Photo</label>
                </div>
                <div class="col-sm-8">
                  <input
                    type="text"
                    id="input-update-modal-teacher-photo"
                    name="teacherPhoto"
                    placeholder="Exp: images/teacher/ted_hawkins.jpg"
                    class="form-control"
                  />
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-update">
              Update Course
            </button>
            <button
              class="btn btn-secondary"
              id="btn-modal-update-cancel"
              data-dismiss="modal"
            >
              Cancel
            </button>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete user modal -->
    <div>
      <div id="delete-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">
                Confirm delete course
              </h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-12">
                    <p>Bạn có chắc chắn muốn xóa course?</p>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-delete-course">
                Confirm Course
              </button>
              <button
                class="btn btn-secondary"
                id="btn-delete-cancel"
                data-dismiss="modal"
              >
                Cancel
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";

    //biến toàn cục để lưu trữ id user đang được update
    var gCourseId = 0;

    var gSTT = 1;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gCOURSES_COLS = [
      "id",
      "coverImage",
      "courseCode",
      "courseName",
      "level",
      "duration",
      "price",
      "discountPrice",
      "teacherName",
      "teacherPhoto",
      "isPopular",
      "isTrending",
      "action",
    ];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gSTT_COL = 0;
    const gCOURSE_COVER_IMAGE_COL = 1;
    const gCOURSE_CODE_COL = 2;
    const gCOURSE_NAME_COL = 3;
    const gLEVEL_COL = 4;
    const gDURATION_COL = 5;
    const gPRICE_COL = 6;
    const gDISCOUNT_PRICE_COL = 7;
    const gTEACHER_NAME_COL = 8;
    const gTEACHER_PHOTO_COL = 9;
    const gTEACHER_IS_POPULAR_COL = 10;
    const gTEACHER_IS_TRENDING_COL = 11;
    const gACTION_COL = 12;

    //khai báo biến toàn cục gNot_SELECT_LEVEL: giá trị option chưa tick chọn level
    const gNOT_SELECT_LEVEL = "NOT_SELECT_LEVEL";
    //khai báo biến toàn cục gNot_SELECT_POPULAR: giá trị option chưa tick chọn course popular
    const gNot_SELECT_POPULAR = "NOT_SELECT_POPULAR";
    //khai báo biến toàn cục gNot_SELECT_TRENDING: giá trị option chưa tick chọn course trending
    const gNot_SELECT_TRENDING = "NOT_SELECT_TRENDING";

    // Khai báo DataTable & mapping collumns
    var gCourseTable = $("#table-course").DataTable({
      columns: [
        // { data: gCOURSES_COLS[gCOURSE_STT_COL] },
        { data: gCOURSES_COLS[gSTT_COL] },
        { data: gCOURSES_COLS[gCOURSE_COVER_IMAGE_COL] },
        { data: gCOURSES_COLS[gCOURSE_CODE_COL] },
        { data: gCOURSES_COLS[gCOURSE_NAME_COL] },
        { data: gCOURSES_COLS[gLEVEL_COL] },
        { data: gCOURSES_COLS[gDURATION_COL] },
        { data: gCOURSES_COLS[gPRICE_COL] },
        { data: gCOURSES_COLS[gDISCOUNT_PRICE_COL] },
        { data: gCOURSES_COLS[gTEACHER_NAME_COL] },
        { data: gCOURSES_COLS[gTEACHER_PHOTO_COL] },
        { data: gCOURSES_COLS[gTEACHER_IS_POPULAR_COL] },
        { data: gCOURSES_COLS[gTEACHER_IS_TRENDING_COL] },
        { data: gCOURSES_COLS[gACTION_COL] },
      ],
      columnDefs: [
        {
          // định nghĩa lại cột STT
          targets: gSTT_COL,
          render: function () {
            return gSTT++;
          },
        },
        {
          // định nghĩa lại cột
          targets: gCOURSE_COVER_IMAGE_COL,
          className: "text-center",
          data: "img",
          render: function (data) {
            return (
              '<img src="' +
              data +
              '" alt="' +
              data +
              '"height="100%" width="100%"/>'
            );
          },
        },
        {
          // định nghĩa lại cột
          targets: gPRICE_COL,
          className: "text-center",
          render: function (data) {
            return data + " $";
          },
        },
        {
          // định nghĩa lại cột
          targets: gDISCOUNT_PRICE_COL,
          render: function (data) {
            return data + " $";
          },
        },
        {
          // định nghĩa lại cột
          targets: gTEACHER_PHOTO_COL,
          data: "img",
          render: function (data) {
            return (
              '<img src="' +
              data +
              '" alt="' +
              data +
              '"height="75%" width="75%" class="rounded-circle"/>'
            );
          },
        },
        {
          // định nghĩa lại cột
          targets: gTEACHER_IS_POPULAR_COL,
          render: function (data) {
            return getChecked(data);
          },
        },
        {
          // định nghĩa lại cột
          targets: gTEACHER_IS_TRENDING_COL,
          render: function (data) {
            return getChecked(data);
          },
        },
        {
          // định nghĩa lại cột action
          targets: gACTION_COL,
          className: "text-center",
          defaultContent: `
                  <button class="btn btn-primary btn-update"><i class="fas fa-edit"></i> Sửa</button>
                  <button class="btn btn-danger btn-delete"><i class="fas fa-trash-alt"></i> Xóa</button>`,
        },
      ],
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      // thực hiện tải trang
      onPageLoading();

      //gán sự kiện credate - 1 course
      $("#btn-add-courses").on("click", function () {
        $("#insert-course-modal").modal("show");
        resetCreateModalCourseForm();
      });

      //gán sự kiện cho nút tạo mới course
      $(document).on("click", "#btn-modal-create", function () {
        onBtnModalCreateCourseClick();
      });

      //gán sự kiện update
      $(document).on("click", ".btn-update", function () {
        onBtnUpdateClick(this);
      });
      //gán sự kiện cho nút update course
      $(document).on("click", "#btn-modal-update", function () {
        onBtnModalUpdateCourseClick(this);
      });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load User to DataTable
      getAllCourses();
    }

    function onBtnModalCreateCourseClick() {
      //khai báo đối tượng
      var vCourseObj = {
        courseCode: "",
        courseName: "",
        price: "",
        discountPrice: "",
        duration: "",
        level: "",
        coverImage: "",
        teacherName: "",
        teacherPhoto: "",
        isPopular: false,
        isTrending: false,
      };

      //thu thập dữ liệu từ form
      getValueInputModalCreate(vCourseObj);

      //kiểm tra dữ liệu
      var vIsCheck = validateDataInputModal(vCourseObj);
      if (vIsCheck) {
        $.ajax({
          url: gBASE_URL + "/courses",
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vCourseObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertCourseSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    function onBtnModalUpdateCourseClick() {
      //khai báo đối tượng
      var vInfoCourseObj = {
        courseCode: "",
        courseName: "",
        price: 0,
        discountPrice: 0,
        duration: "",
        level: "",
        coverImage: "",
        teacherName: "",
        teacherPhoto: "",
        isPopular: false,
        isTrending: false,
      };

      //thu thập dữ liệu từ form
      getCourseDataUpdate(vInfoCourseObj);

      //kiểm tra dữ liệu
      var vIsCheck = validateDataInputModal(vInfoCourseObj);
      if (vIsCheck) {
        $.ajax({
          url: gBASE_URL + "/courses" + gCourseId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vInfoCourseObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleUpdateCourseSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    // Hàm xử lý sự kiện khi nút update được ấn
    function onBtnUpdateClick(paramUpdate) {
      gCourseId = getCourseIdFromButton(paramUpdate);
      console.log("Nút sửa được nhấn");
      console.log("Id của course là: " + gCourseId);
      //load data into form
      getCourseById(gCourseId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách course đăng ký
    function getAllCourses() {
      $.ajax({
        url: gBASE_URL + "/courses",
        type: "GET",
        success: function (paramCourses) {
          loadDataToCourseTable(paramCourses);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }
    /** load course array to DataTable
     * in: course array
     * out: course table has data
     */
    function loadDataToCourseTable(paramCourseArr) {
      gCourseTable.clear();
      gCourseTable.rows.add(paramCourseArr);
      gCourseTable.draw();
    }

    //hàm để render lại cột is popular và cột is trending
    function getChecked(paramData) {
      "use strict";
      var vCheck = '<input type="checkbox" checked="checked" disabled: true>';
      if (!paramData) {
        vCheck = '<input type="checkbox" disabled:true>';
      }
      return vCheck;
    }

    //hàm xóa trắng form create course
    function resetCreateModalCourseForm() {
      $("#input-modal-course-code").val("");
      $("#input-modal-course-name").val("");
      $("#input-modal-duration").val("");
      $("#input-modal-price").val("");
      $("#input-modal-discount").val("");
      $("#input-modal-teacher-name").val("");
      $("#input-modal-course-photo").val("");
      $("#input-modal-teacher-photo").val("");
    }

    //thu thập dữ liệu nhập vào insert course
    function getValueInputModalCreate(paramInputCreate) {
      paramInputCreate.courseCode = $("#input-modal-course-code").val().trim();
      paramInputCreate.courseName = $("#input-modal-course-name").val().trim();
      paramInputCreate.level = $("#select-modal-level").val();

      //is popular
      var vValueIsPopular = $("#select-modal-popular").val();
      if (vValueIsPopular != gNot_SELECT_POPULAR) {
        var vKiemTraBooleanPopular = false;
        if (vValueIsPopular == "true") {
          vKiemTraBooleanPopular = true;
        }
        paramInputCreate.isPopular = vKiemTraBooleanPopular;
      } else {
        paramInputCreate.isPopular = gNot_SELECT_POPULAR;
      }
      //is trending
      var vValueIsTrending = $("#select-modal-trending").val();
      if (vValueIsTrending != gNot_SELECT_TRENDING) {
        var vKiemTraBooleanTrending = false;
        if (vValueIsTrending == "true") {
          vKiemTraBooleanTrending = true;
        }
        paramInputCreate.isTrending = vKiemTraBooleanTrending;
      } else {
        paramInputCreate.isTrending = gNot_SELECT_TRENDING;
      }

      paramInputCreate.duration = $("#input-modal-duration").val().trim();

      paramInputCreate.price = $("#input-modal-price").val().trim();
      paramInputCreate.discountPrice = $("#input-modal-discount").val().trim();
      paramInputCreate.teacherName = $("#input-modal-teacher-name")
        .val()
        .trim();
      paramInputCreate.coverImage = $("#input-modal-course-photo").val();
      paramInputCreate.teacherPhoto = $("#input-modal-teacher-photo").val();
    }

    //hàm kiểm tra dữ liệu insert user
    function validateDataInputModal(paramInputCreate) {
      if (paramInputCreate.coverImage === "") {
        alert("Dường dẫn ảnh nền chưa được nhập.");
        return false;
      }
      if (isFinite(paramInputCreate.coverImage)) {
        alert("Cover Image is not number.");
        return false;
      }
      if (paramInputCreate.courseCode === "") {
        alert("Course code chưa được nhập.");
        return false;
      }
      if (isFinite(paramInputCreate.courseCode)) {
        alert("Course code is not number.");
        return false;
      }
      if (paramInputCreate.courseName === "") {
        alert("Course name chưa được nhập.");
        return false;
      }
      if (isFinite(paramInputCreate.courseName)) {
        alert("Course name is not number.");
        return false;
      }
      //kiểm tra level được chọn chưa
      if (paramInputCreate.level === gNOT_SELECT_LEVEL) {
        alert("Chưa chọn level.");
        return false;
      }
      //kiểm tra tích popular
      if (paramInputCreate.isPopular === gNot_SELECT_POPULAR) {
        alert("Chưa chọn popular.");
        return false;
      }
      //kiểm tra tích trending
      if (paramInputCreate.isTrending === gNot_SELECT_TRENDING) {
        alert("Chưa chọn trending.");
        return false;
      }
      if (paramInputCreate.duration === "") {
        alert("Duration chưa được nhập.");
        return false;
      }
      if (paramInputCreate.price === "") {
        alert("Price chưa được nhập.");
        return false;
      }
      if (!isFinite(paramInputCreate.price)) {
        alert("Price phải nhập số.");
        return false;
      }
      if (paramInputCreate.discountPrice != "") {
        if (!isFinite(paramInputCreate.discountPrice)) {
          alert("Discount Price phải nhập số.");
          return false;
        }
        //nếu discount > price báo lỗi
        if (paramInputCreate.discountPrice >= paramInputCreate.price) {
          alert("Discount Price phải nhỏ hơn price.");
          return false;
        }
      }
      if (paramInputCreate.teacherName === "") {
        alert("Teacher name chưa được nhập.");
        return false;
      }
      if (isFinite(paramInputCreate.teacherName)) {
        alert("Teacher name không phải là số.");
        return false;
      }
      if (paramInputCreate.teacherPhoto === "") {
        alert("Teacher photo chưa được nhập.");
        return false;
      }
      if (isFinite(paramInputCreate.teacherPhoto)) {
        alert("Teacher photo không phải là số.");
        return false;
      }
      return true;
    }

    //xử lý sự kiện khi nhấn nút button tạo course
    function handleInsertCourseSuccess() {
      alert("Thêm course thành công!");
      $("#insert-course-modal").modal("hide");
      resetCreateCourseForm();
      getAllCourses();
    }

    //hàm dựa vào button detail (edit or delete) xác định được id user
    function getCourseIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vCourseRowData = gCourseTable.row(vTableRow).data();
      return vCourseRowData.id;
    }

    // hàm get course by id
    function getCourseById(paramCourseId) {
      $.ajax({
        url: gBASE_URL + "/courses/" + paramCourseId,
        type: "GET",
        success: function (paramCourse) {
          showCourseDataToModal(paramCourse);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }

    //hàm show course obj lên modal
    //hàm hiển thị course ra form
    function showCourseDataToModal(paramCourse) {
      $("#input-update-modal-course-code").val(paramCourse.courseCode);
      $("#input-update-modal-course-name").val(paramCourse.courseName);
      $("#input-update-modal-course-photo").val(paramCourse.coverImage);
      $("#input-update-modal-duration").val(paramCourse.duration);
      $("#select-update-modal-level").val(paramCourse.level);
      $("#input-update-modal-price").val(paramCourse.price);
      $("#input-update-modal-discount").val(paramCourse.discountPrice);
      $("#input-update-modal-teacher-name").val(paramCourse.teacherName);
      $("#input-update-modal-teacher-photo").val(paramCourse.teacherPhoto);
      var vGetValueIsPopular = paramCourse.isPopular;
      if (vGetValueIsPopular) {
        $("#select-update-modal-popular").val("true");
      } else {
        $("#select-update-modal-popular").val("false");
      }
      var vGetValueIsTrending = paramCourse.isTrending;
      if (vGetValueIsTrending) {
        $("#select-update-modal-trending").val("true");
      } else {
        $("#select-update-modal-trending").val("false");
      }
      //hiển thị modal
      $("#update-course-modal").modal("show");
    }

    //thu thập dữ liệu nhập vào insert course
    function getCourseDataUpdate(paramInputCreate) {
      paramInputCreate.courseCode = $("#input-update-modal-course-code")
        .val()
        .trim();
      paramInputCreate.courseName = $("#input-update-modal-course-name")
        .val()
        .trim();
      paramInputCreate.level = $("#select-update-modal-level").val();

      //is popular
      var vValueIsPopular = $("#select-update-modal-popular").val();
      var vKiemTraBooleanPopular = false;
      if (vValueIsPopular == "true") {
        vKiemTraBooleanPopular = true;
      }
      paramInputCreate.isPopular = vKiemTraBooleanPopular;

      //is trending
      var vValueIsTrending = $("#select-update-modal-trending").val();
      var vKiemTraBooleanTrending = false;
      if (vValueIsTrending == "true") {
        vKiemTraBooleanTrending = true;
      }
      paramInputCreate.isTrending = vKiemTraBooleanTrending;

      paramInputCreate.duration = $("#input-update-modal-duration")
        .val()
        .trim();

      paramInputCreate.price = $("#input-update-modal-price").val().trim();
      paramInputCreate.discountPrice = $("#input-update-modal-discount")
        .val()
        .trim();
      paramInputCreate.teacherName = $("#input-update-modal-teacher-name")
        .val()
        .trim();
      paramInputCreate.coverImage = $("#input-update-modal-course-photo").val();
      paramInputCreate.teacherPhoto = $(
        "#input-update-modal-teacher-photo"
      ).val();
    }

    //xử lý sự kiện khi nhấn nút button tạo course
    function handleUpdateCourseSuccess() {
      alert("Thêm course thành công!");
      getAllCourses();
      clearUpdateModalCourseForm();
      $("#update-course-modal").modal("hide");
    }

    //hàm xóa trắng form update course
    function clearUpdateModalCourseForm() {
      $("#input-update-modal-course-code").val("");
      $("#input-update-modal-course-name").val("");
      $("#input-update-modal-duration").val("");
      $("#input-update-modal-price").val("");
      $("#input-update-modal-discount").val("");
      $("#input-update-modal-teacher-name").val("");
      $("#input-update-modal-course-photo").val("");
      $("#input-update-modal-teacher-photo").val("");
    }
  </script>
</html>
